/*
 MB91310 series I/O register declaration file V60L04
 ALL RIGHTS RESERVED, COPYRIGHT (C) FUJITSU LIMITED 2002
 LICENSED MATERIAL - PROGRAM PROPERTY OF FUJITSU LIMITED
*/

#ifdef __FASM__
 #include "_ra91310.h"
#else
 #include "_r91310.h"
#endif

/* I/O Area Address */
#ifdef __IO_DEFINE
 #ifdef __FASM__
        .section    IO_REG,     IOCOMMON,locate=0x000000
 #else
  #pragma section IO=IO_REG,attr=IOCOMMON,locate=0x000000
 #endif
#endif

__IO_STATIC  __RESERVE_D(	dmy_00_0F, 16)	/* addr 000-00Fh */
__IO_EXTERN  __UNION_D(io_pdr0,	IO_PDR0)	/* addr 010h */
__IO_EXTERN  __UNION_D(io_pdr1,	IO_PDR1)	/* addr 011h */
__IO_EXTERN  __UNION_D(io_pdr2,	IO_PDR2)	/* addr 012h */
__IO_EXTERN  __UNION_D(io_pdr3,	IO_PDR3)	/* addr 013h */
__IO_EXTERN  __UNION_D(io_pdr4,	IO_PDR4)	/* addr 014h */
__IO_EXTERN  __UNION_D(io_pdr5,	IO_PDR5)	/* addr 015h */
__IO_EXTERN  __UNION_D(io_pdr6,	IO_PDR6)	/* addr 016h */
__IO_EXTERN  __UNION_D(io_pdr7,	IO_PDR7)	/* addr 017h */
__IO_STATIC  __RESERVE_D(	dmy_18_1F, 8)	/* addr 018-01Fh */
__IO_EXTERN  __UNION_D(io_adct,	IO_ADCT)	/* addr 020-021h */
__IO_EXTERN  __USHORT_D(	IO_ADCH)	/* addr 022-023h */
__IO_EXTERN  __USHORT_D(	IO_ADAT0)	/* addr 024-025h */
__IO_EXTERN  __USHORT_D(	IO_ADAT1)	/* addr 026-027h */
__IO_EXTERN  __USHORT_D(	IO_ADAT2)	/* addr 028-029h */
__IO_EXTERN  __USHORT_D(	IO_ADAT3)	/* addr 02A-02Bh */
__IO_EXTERN  __USHORT_D(	IO_ADAT4)	/* addr 02C-02Dh */
__IO_EXTERN  __USHORT_D(	IO_ADAT5)	/* addr 02E-02Fh */
__IO_EXTERN  __USHORT_D(	IO_ADAT6)	/* addr 030-031h */
__IO_EXTERN  __USHORT_D(	IO_ADAT7)	/* addr 032-033h */
__IO_EXTERN  __USHORT_D(	IO_ADAT8)	/* addr 034-035h */
__IO_EXTERN  __USHORT_D(	IO_ADAT9)	/* addr 036-037h */
__IO_STATIC  __RESERVE_D(	dmy_38_3F, 8)	/* addr 038-03Fh */
__IO_EXTERN  __UNION_D(io_eirr,	IO_EIRR)	/* addr 040h */
__IO_EXTERN  __UNION_D(io_enir,	IO_ENIR)	/* addr 041h */
__IO_EXTERN  __UNION_D(io_elvr,	IO_ELVR)	/* addr 042-43h */
__IO_EXTERN  __UNION_D(io_dicr,	IO_DICR)	/* addr 044h */
__IO_EXTERN  __UNION_D(io_hrcl,	IO_HRCL)	/* addr 045h */
__IO_STATIC  __RESERVE_D(	dmy_46_47, 2)	/* addr 046-047h */
__IO_EXTERN  __USHORT_D(	IO_TMRLR0)	/* addr 048-049h */
__IO_EXTERN  __USHORT_D(	IO_TMR0)	/* addr 04A-04Bh */
__IO_STATIC  __RESERVE_D(	dmy_4C_4D, 2)	/* addr 04C-04Dh */
__IO_EXTERN  __UNION_D(io_tmcsr,IO_TMCSR0)	/* addr 04E-04Fh */
__IO_EXTERN  __USHORT_D(	IO_TMRLR1)	/* addr 050-051h */
__IO_EXTERN  __USHORT_D(	IO_TMR1)	/* addr 052-053h */
__IO_STATIC  __RESERVE_D(	dmy_54_55, 2)	/* addr 054-055h */
__IO_EXTERN  __UNION_D(io_tmcsr,IO_TMCSR1)	/* addr 056-057h */
__IO_EXTERN  __USHORT_D(	IO_TMRLR2)	/* addr 058-059h */
__IO_EXTERN  __USHORT_D(	IO_TMR2)	/* addr 05A-05Bh */
__IO_STATIC  __RESERVE_D(	dmy_5C_5D, 2)	/* addr 05C-05Dh */
__IO_EXTERN  __UNION_D(io_tmcsr,IO_TMCSR2)	/* addr 05E-05Fh */
__IO_EXTERN  __UNION_D(io_ssr,	IO_SSR0)	/* addr 060h */
__IO_EXTERN  __UCHAR_D(		IO_SIDR0)	/* addr 061h */
__IO_EXTERN  __UNION_D(io_scr,	IO_SCR0)	/* addr 062h */
__IO_EXTERN  __UNION_D(io_smr,	IO_SMR0)	/* addr 063h */
__IO_EXTERN  __USHORT_D(	IO_UTIM0)	/* addr 064-065h */
__IO_EXTERN  __UCHAR_D(		IO_DRCL0)	/* addr 066h */
__IO_EXTERN  __UNION_D(io_utimc,IO_UTIMC0)	/* addr 067h */
__IO_EXTERN  __UNION_D(io_ssr,	IO_SSR1)	/* addr 068h */
__IO_EXTERN  __UCHAR_D(		IO_SIDR1)	/* addr 069h */
__IO_EXTERN  __UNION_D(io_scr,	IO_SCR1)	/* addr 06Ah */
__IO_EXTERN  __UNION_D(io_smr,	IO_SMR1)	/* addr 06Bh */
__IO_EXTERN  __USHORT_D(	IO_UTIM1)	/* addr 06C-06Dh */
__IO_EXTERN  __UCHAR_D(		IO_DRCL1)	/* addr 06Eh */
__IO_EXTERN  __UNION_D(io_utimc,IO_UTIMC1)	/* addr 06Fh */
__IO_EXTERN  __UNION_D(io_ssr,	IO_SSR2)	/* addr 070h */
__IO_EXTERN  __UCHAR_D(		IO_SIDR2)	/* addr 071h */
__IO_EXTERN  __UNION_D(io_scr,	IO_SCR2)	/* addr 072h */
__IO_EXTERN  __UNION_D(io_smr,	IO_SMR2)	/* addr 073h */
__IO_EXTERN  __USHORT_D(	IO_UTIM2)	/* addr 074-075h */
__IO_EXTERN  __UCHAR_D(		IO_DRCL2)	/* addr 076h */
__IO_EXTERN  __UNION_D(io_utimc,IO_UTIMC2)	/* addr 077h */
__IO_EXTERN  __UNION_D(io_ssr,	IO_SSR3)	/* addr 078h */
__IO_EXTERN  __UCHAR_D(		IO_SIDR3)	/* addr 079h */
__IO_EXTERN  __UNION_D(io_scr,	IO_SCR3)	/* addr 07Ah */
__IO_EXTERN  __UNION_D(io_smr,	IO_SMR3)	/* addr 07Bh */
__IO_EXTERN  __USHORT_D(	IO_UTIM3)	/* addr 07C-07Dh */
__IO_EXTERN  __UCHAR_D(		IO_DRCL3)	/* addr 07Eh */
__IO_EXTERN  __UNION_D(io_utimc,IO_UTIMC3)	/* addr 07Fh */
__IO_EXTERN  __UNION_D(io_ssr,	IO_SSR4)	/* addr 080h */
__IO_EXTERN  __UCHAR_D(		IO_SIDR4)	/* addr 081h */
__IO_EXTERN  __UNION_D(io_scr,	IO_SCR4)	/* addr 082h */
__IO_EXTERN  __UNION_D(io_smr,	IO_SMR4)	/* addr 083h */
__IO_EXTERN  __USHORT_D(	IO_UTIM4)	/* addr 084-085h */
__IO_EXTERN  __UCHAR_D(		IO_DRCL4)	/* addr 086h */
__IO_EXTERN  __UNION_D(io_utimc,IO_UTIMC4)	/* addr 087h */
__IO_STATIC  __RESERVE_D(	dmy_88_8F, 8)	/* addr 088-08Fh */
__IO_EXTERN  __UNION_D(io_pwcc, IO_PWCC)	/* addr 090-091h */
__IO_STATIC  __RESERVE_D(	dmy_92_93, 2)	/* addr 092-093h */
__IO_EXTERN  __USHORT_D(	IO_PWCD)	/* addr 094-095h */
__IO_STATIC  __RESERVE_D(	dmy_96_B3, 30)	/* addr 092-0B3h */
__IO_EXTERN  __UNION_D(io_ibcr,	IO_IBCR0)	/* addr 0B4h */
__IO_EXTERN  __UNION_D(io_ibsr,	IO_IBSR0)	/* addr 0B5h */
__IO_EXTERN  __UNION_D(io_itba,	IO_ITBA0)	/* addr 0B6-0B7h */
__IO_EXTERN  __UNION_D(io_itmk,	IO_ITMK0)	/* addr 0B8-0B9h */
__IO_EXTERN  __UNION_D(io_ismk,	IO_ISMK0)	/* addr 0BAh */
__IO_EXTERN  __UNION_D(io_isba,	IO_ISBA0)	/* addr 0BBh */
__IO_STATIC  __RESERVE_D(	dmy_BC, 1)	/* addr 0BCh */
__IO_EXTERN  __UCHAR_D(		IO_IDAR0)	/* addr 0BDh */
__IO_EXTERN  __UNION_D(io_iccr,	IO_ICCR0)	/* addr 0BEh */
__IO_EXTERN  __UNION_D(io_idbl,	IO_IDBL0)	/* addr 0BFh */
__IO_STATIC  __RESERVE_D(	dmy_C0_C3, 4)	/* addr 0C0-0C3h */
__IO_EXTERN  __UNION_D(io_ibcr,	IO_IBCR1)	/* addr 0C4h */
__IO_EXTERN  __UNION_D(io_ibsr,	IO_IBSR1)	/* addr 0C5h */
__IO_EXTERN  __UNION_D(io_itba,	IO_ITBA1)	/* addr 0C6-0C7h */
__IO_EXTERN  __UNION_D(io_itmk,	IO_ITMK1)	/* addr 0C8-0C9h */
__IO_EXTERN  __UNION_D(io_ismk,	IO_ISMK1)	/* addr 0CAh */
__IO_EXTERN  __UNION_D(io_isba,	IO_ISBA1)	/* addr 0CBh */
__IO_STATIC  __RESERVE_D(	dmy_CC, 1)	/* addr 0CCh */
__IO_EXTERN  __UCHAR_D(		IO_IDAR1)	/* addr 0CDh */
__IO_EXTERN  __UNION_D(io_iccr,	IO_ICCR1)	/* addr 0CEh */
__IO_EXTERN  __UNION_D(io_idbl,	IO_IDBL1)	/* addr 0CFh */
__IO_STATIC  __RESERVE_D(	dmy_D0_D3, 4)	/* addr 0D0-0D3h */
__IO_EXTERN  __UNION_D(io_ibcr,	IO_IBCR2)	/* addr 0D4h */
__IO_EXTERN  __UNION_D(io_ibsr,	IO_IBSR2)	/* addr 0D5h */
__IO_EXTERN  __UNION_D(io_itba,	IO_ITBA2)	/* addr 0D6-0D7h */
__IO_EXTERN  __UNION_D(io_itmk,	IO_ITMK2)	/* addr 0D8-0D9h */
__IO_EXTERN  __UNION_D(io_ismk,	IO_ISMK2)	/* addr 0DAh */
__IO_EXTERN  __UNION_D(io_isba,	IO_ISBA2)	/* addr 0DBh */
__IO_STATIC  __RESERVE_D(	dmy_DC, 1)	/* addr 0DCh */
__IO_EXTERN  __UCHAR_D(		IO_IDAR2)	/* addr 0DDh */
__IO_EXTERN  __UNION_D(io_iccr,	IO_ICCR2)	/* addr 0DEh */
__IO_EXTERN  __UNION_D(io_idbl,	IO_IDBL2)	/* addr 0DFh */
__IO_STATIC  __RESERVE_D(	dmy_E0_E3, 4)	/* addr 0E0-0E3h */
__IO_EXTERN  __UNION_D(io_ibcr,	IO_IBCR3)	/* addr 0E4h */
__IO_EXTERN  __UNION_D(io_ibsr,	IO_IBSR3)	/* addr 0E5h */
__IO_EXTERN  __UNION_D(io_itba,	IO_ITBA3)	/* addr 0E6-0E7h */
__IO_EXTERN  __UNION_D(io_itmk,	IO_ITMK3)	/* addr 0E8-0E9h */
__IO_EXTERN  __UNION_D(io_ismk,	IO_ISMK3)	/* addr 0EAh */
__IO_EXTERN  __UNION_D(io_isba,	IO_ISBA3)	/* addr 0EBh */
__IO_STATIC  __RESERVE_D(	dmy_9C, 1)	/* addr 0ECh */
__IO_EXTERN  __UCHAR_D(		IO_IDAR3)	/* addr 0EDh */
__IO_EXTERN  __UNION_D(io_iccr,	IO_ICCR3)	/* addr 0EEh */
__IO_EXTERN  __UNION_D(io_idbl,	IO_IDBL3)	/* addr 0EFh */
__IO_EXTERN  __UNION_D(io_t0lpcr, IO_T0LPCR)	/* addr 0F0h */
__IO_EXTERN  __UNION_D(io_tnccr,  IO_T0CCR)	/* addr 0F1h */
__IO_EXTERN  __UNION_D(io_tntcr,  IO_T0TCR)	/* addr 0F2h */
__IO_EXTERN  __UNION_D(io_tnr,    IO_T0R)	/* addr 0F3h */
__IO_EXTERN  __USHORT_D(	  IO_T0DRR)	/* addr 0F4-0F5h */
__IO_EXTERN  __USHORT_D(	  IO_T0CRR)	/* addr 0F6-0F7h */
__IO_EXTERN  __UNION_D(io_t1lpcr, IO_T1LPCR)	/* addr 0F8h */
__IO_EXTERN  __UNION_D(io_tnccr,  IO_T1CCR)	/* addr 0F9h */
__IO_EXTERN  __UNION_D(io_tntcr,  IO_T1TCR)	/* addr 0FAh */
__IO_EXTERN  __UNION_D(io_tnr,    IO_T1R)	/* addr 0FBh */
__IO_EXTERN  __USHORT_D(	  IO_T1DRR)	/* addr 0FC-0FDh */
__IO_EXTERN  __USHORT_D(	  IO_T1CRR)	/* addr 0FE-0FFh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T2LPCR,COMMON,locate=0x000100
#endif

__EXTERN  __UNION_D(io_t2lpcr,	IO_T2LPCR)	/* addr 100h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T2CCR,COMMON,locate=0x000101
#endif

__EXTERN  __UNION_D(io_tnccr,	IO_T2CCR)	/* addr 101h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T2TCR,COMMON,locate=0x000102
#endif

__EXTERN  __UNION_D(io_tntcr,	IO_T2TCR)	/* addr 102h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T2R,COMMON,locate=0x000103
#endif

__EXTERN  __UNION_D(io_tnr,	IO_T2R)		/* addr 103h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T2DRR,COMMON,locate=0x000104
#endif

__EXTERN  __USHORT_D(		IO_T2DRR)	/* addr 104-105h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T2CRR,COMMON,locate=0x000106
#endif

__EXTERN  __USHORT_D(		IO_T2CRR)	/* addr 106-107h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T3LPCR,COMMON,locate=0x000108
#endif

__EXTERN  __UNION_D(io_t3lpcr,	IO_T3LPCR)	/* addr 108h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T3CCR,COMMON,locate=0x000109
#endif

__EXTERN  __UNION_D(io_tnccr,	IO_T3CCR)	/* addr 109h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T3TCR,COMMON,locate=0x00010A
#endif

__EXTERN  __UNION_D(io_tntcr,	IO_T3TCR)	/* addr 10Ah */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T3R,COMMON,locate=0x00010B
#endif

__EXTERN  __UNION_D(io_tnr,	IO_T3R)		/* addr 10Bh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T3DRR,COMMON,locate=0x00010C
#endif

__EXTERN  __USHORT_D(		IO_T3DRR)	/* addr 10C-10Dh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_T3CRR,COMMON,locate=0x00010E
#endif

__EXTERN  __USHORT_D(		IO_T3CRR)	/* addr 10E-10Fh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PRMR0,COMMON,locate=0x000120
#endif

__EXTERN  __USHORT_D(		IO_PTMR0)	/* addr 120-121h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PCSR0,COMMON,locate=0x000122
#endif

__EXTERN  __USHORT_D(		IO_PCSR0)	/* addr 122-123h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PDUT0,COMMON,locate=0x000124
#endif

__EXTERN  __USHORT_D(		IO_PDUT0)	/* addr 124-125h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PCN0,COMMON,locate=0x000126
#endif

__EXTERN  __UNION_D(io_pcn,	IO_PCN0)	/* addr 126-127h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PRMR1,COMMON,locate=0x000128
#endif

__EXTERN  __USHORT_D(		IO_PTMR1)	/* addr 128-129h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PCSR1,COMMON,locate=0x00012A
#endif

__EXTERN  __USHORT_D(		IO_PCSR1)	/* addr 12A-12Bh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PDUT1,COMMON,locate=0x00012C
#endif

__EXTERN  __USHORT_D(		IO_PDUT1)	/* addr 12C-12Dh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PCN1,COMMON,locate=0x00012E
#endif

__EXTERN  __UNION_D(io_pcn,	IO_PCN1)	/* addr 12E-12Fh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PRMR2,COMMON,locate=0x000130
#endif

__EXTERN  __USHORT_D(		IO_PTMR2)	/* addr 130-131h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PCSR2,COMMON,locate=0x000132
#endif

__EXTERN  __USHORT_D(		IO_PCSR2)	/* addr 132-133h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PDUT2,COMMON,locate=0x000134
#endif

__EXTERN  __USHORT_D(		IO_PDUT2)	/* addr 134-135h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PCN2,COMMON,locate=0x000136
#endif

__EXTERN  __UNION_D(io_pcn,	IO_PCN2)	/* addr 136-137h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PRMR3,COMMON,locate=0x000138
#endif

__EXTERN  __USHORT_D(		IO_PTMR3)	/* addr 138-139h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PCSR3,COMMON,locate=0x00013A
#endif

__EXTERN  __USHORT_D(		IO_PCSR3)	/* addr 13A-13Bh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PDUT3,COMMON,locate=0x00013C
#endif

__EXTERN  __USHORT_D(		IO_PDUT3)	/* addr 13C-13Dh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PCN3,COMMON,locate=0x00013E
#endif

__EXTERN  __UNION_D(io_pcn,	IO_PCN3)	/* addr 13E-13Fh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACA0,COMMON,locate=0x000200
#endif

__EXTERN  __UNION_D(io_dmaca,	IO_DMACA0)	/* addr 200-203h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACB0,COMMON,locate=0x000204
#endif

__EXTERN  __UNION_D(io_dmacb,	IO_DMACB0)	/* addr 204-207h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACA1,COMMON,locate=0x000208
#endif

__EXTERN  __UNION_D(io_dmaca,	IO_DMACA1)	/* addr 208-20Bh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACB1,COMMON,locate=0x00020C
#endif

__EXTERN  __UNION_D(io_dmacb,	IO_DMACB1)	/* addr 20C-20Fh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACA2,COMMON,locate=0x000210
#endif

__EXTERN  __UNION_D(io_dmaca,	IO_DMACA2)	/* addr 210-213h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACB2,COMMON,locate=0x000214
#endif

__EXTERN  __UNION_D(io_dmacb,	IO_DMACB2)	/* addr 214-217h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACA3,COMMON,locate=0x000218
#endif

__EXTERN  __UNION_D(io_dmaca,	IO_DMACA3)	/* addr 218-21Bh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACB3,COMMON,locate=0x00021C
#endif

__EXTERN  __UNION_D(io_dmacb,	IO_DMACB3)	/* addr 21C-21Fh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACA4,COMMON,locate=0x000220
#endif

__EXTERN  __UNION_D(io_dmaca,	IO_DMACA4)	/* addr 220-223h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACB4,COMMON,locate=0x000224
#endif

__EXTERN  __UNION_D(io_dmacb,	IO_DMACB4)	/* addr 224-227h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMACR,COMMON,locate=0x000240
#endif

__EXTERN  __UNION_D(io_dmacr,	IO_DMACR)	/* addr 240-243h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_BSD0,COMMON,locate=0x0003F0
#endif

__EXTERN  __ULONG_D(		IO_BSD0)	/* addr 3F0-3F3h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_BSD1,COMMON,locate=0x0003F4
#endif

__EXTERN  __ULONG_D(		IO_BSD1)	/* addr 3F4-3F7h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_BSDC,COMMON,locate=0x0003F8
#endif

__EXTERN  __ULONG_D(		IO_BSDC)	/* addr 3F8-3FBh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_BSRR,COMMON,locate=0x0003FC
#endif

__EXTERN  __ULONG_D(		IO_BSRR)	/* addr 3FC-3FFh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_PORT,COMMON,locate=0x000400
#endif

__EXTERN  __STRUCT_D(io_port,	IO_PORT)	/* addr 400-41Fh */


#ifdef __IO_DEFINE
 #ifdef __FASM__
  .section IO_ICR,COMMON,locate=0x000440
 #else
  #pragma section DATA=IO_ICR,locate=0x000440
 #endif
#endif

__IO_DATA_EXTERN  __UNION_AD(io_icr,IO_ICR, 48)	/* addr 440-46Fh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_CLK,COMMON,locate=0x000480
#endif

__EXTERN  __STRUCT_D(io_clk,	IO_CLK)		/* addr 480-48Bh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_WPCR,COMMON,locate=0x00048C
#endif

__EXTERN  __UNION_D(io_wpcr,	IO_WPCR)	/* addr 48Ch */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_OSCR,COMMON,locate=0x000490
#endif

__EXTERN  __UNION_D(io_oscr,	IO_OSCR)	/* addr 490h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_EBUS,COMMON,locate=0x000640
#endif

__EXTERN  __STRUCT_D(io_ebus,	IO_EBUS)	/* addr 640-683h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_MODR,COMMON,locate=0x0007FD
#endif

__EXTERN  __UCHAR_D(		IO_MODR)	/* addr 7FDh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_DMAD,COMMON,locate=0x001000
#endif

__EXTERN  __STRUCT_D(io_dmad,	IO_DMAD)	/* addr 1000-1027h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_FLCR,COMMON,locate=0x007000
#endif

__EXTERN  __UNION_D(io_flcr,	IO_FLCR)	/* addr 7000h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_FLWC,COMMON,locate=0x007004
#endif

__EXTERN  __UNION_D(io_flwc,	IO_FLWC)	/* addr 7004h */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_USBH,COMMON,locate=0x00050000
#endif

__EXTERN  __STRUCT_D(io_usbh,	IO_USBH)	/* addr 50000-5005Bh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_USBF,COMMON,locate=0x00060000
#endif

__EXTERN  __STRUCT_D(io_usbf,	IO_USBF)	/* addr 60000-6007Fh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_MEMS,COMMON,locate=0x00070000
#endif

__EXTERN  __STRUCT_D(io_mems,	IO_MEMS)	/* addr 70000-7000Bh */


#if defined(__FASM__) && defined(__IO_DEFINE)
    .section IO_OSDC,COMMON,locate=0x00078000
#endif

__EXTERN  __STRUCT_D(io_osdc,	IO_OSDC)	/* addr 78000-7805Fh */
